diff -ruN vdr-1.5.7/dvbdevice.c vdr-1.5.8/dvbdevice.c
--- vdr-1.5.7/dvbdevice.c	2007-02-25 12:46:52.000000000 +0100
+++ vdr-1.5.8/dvbdevice.c	2007-08-17 15:37:56.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.c 1.164 2007/02/25 11:46:52 kls Exp $
+ * $Id: dvbdevice.c 1.165 2007/08/17 13:37:56 kls Exp $
  */
 
 #include "dvbdevice.h"
@@ -793,18 +793,25 @@
 
 bool cDvbDevice::SetChannelDevice(const cChannel *Channel, bool LiveView)
 {
+  int apid = Channel->Apid(0);
+  int vpid = Channel->Vpid();
+  int dpid = Channel->Dpid(0);
+
   bool DoTune = !dvbTuner->IsTunedTo(Channel);
 
+  bool pidHandlesVideo = pidHandles[ptVideo].pid == vpid;
+  bool pidHandlesAudio = pidHandles[ptAudio].pid == apid;
+
   bool TurnOffLivePIDs = HasDecoder()
                          && (DoTune
                             || !IsPrimaryDevice()
                             || LiveView // for a new live view the old PIDs need to be turned off
-                            || pidHandles[ptVideo].pid == Channel->Vpid() // for recording the PIDs must be shifted from DMX_PES_AUDIO/VIDEO to DMX_PES_OTHER
+                            || pidHandlesVideo // for recording the PIDs must be shifted from DMX_PES_AUDIO/VIDEO to DMX_PES_OTHER
                             );
 
   bool StartTransferMode = IsPrimaryDevice() && !DoTune
-                           && (LiveView && HasPid(Channel->Vpid() ? Channel->Vpid() : Channel->Apid(0)) && (pidHandles[ptVideo].pid != Channel->Vpid() || (pidHandles[ptAudio].pid != Channel->Apid(0) && (Channel->Dpid(0) ? pidHandles[ptAudio].pid != Channel->Dpid(0) : true)))// the PID is already set as DMX_PES_OTHER
-                              || !LiveView && (pidHandles[ptVideo].pid == Channel->Vpid() || pidHandles[ptAudio].pid == Channel->Apid(0)) // a recording is going to shift the PIDs from DMX_PES_AUDIO/VIDEO to DMX_PES_OTHER
+                           && (LiveView && HasPid(vpid ? vpid : apid) && (!pidHandlesVideo || (!pidHandlesAudio && (dpid ? pidHandles[ptAudio].pid != dpid : true)))// the PID is already set as DMX_PES_OTHER
+                              || !LiveView && (pidHandlesVideo || pidHandlesAudio) // a recording is going to shift the PIDs from DMX_PES_AUDIO/VIDEO to DMX_PES_OTHER
                               );
   if (CamSlot() && !ChannelCamRelations.CamDecrypt(Channel->GetChannelID(), CamSlot()->SlotNumber()))
      StartTransferMode |= LiveView && IsPrimaryDevice() && Channel->Ca() >= CA_ENCRYPTED_MIN;
@@ -836,7 +843,7 @@
 
   if (TurnOnLivePIDs) {
      SetAudioBypass(false);
-     if (!(AddPid(Channel->Ppid(), ptPcr) && AddPid(Channel->Vpid(), ptVideo) && AddPid(Channel->Apid(0), ptAudio))) {
+     if (!(AddPid(Channel->Ppid(), ptPcr) && AddPid(vpid, ptVideo) && AddPid(apid, ptAudio))) {
         esyslog("ERROR: failed to set PIDs for channel %d on device %d", Channel->Number(), CardIndex() + 1);
         return false;
         }
@@ -848,7 +855,7 @@
      CHECK(ioctl(fd_audio, AUDIO_SET_AV_SYNC, true));
      }
   else if (StartTransferMode)
-     cControl::Launch(new cTransferControl(this, Channel->GetChannelID(), Channel->Vpid(), Channel->Apids(), Channel->Dpids(), Channel->Spids()));
+     cControl::Launch(new cTransferControl(this, Channel->GetChannelID(), vpid, Channel->Apids(), Channel->Dpids(), Channel->Spids()));
 
   return true;
 }
diff -ruN vdr-1.5.7/i18n-to-gettext.pl vdr-1.5.8/i18n-to-gettext.pl
--- vdr-1.5.7/i18n-to-gettext.pl	2007-08-12 12:02:01.000000000 +0200
+++ vdr-1.5.8/i18n-to-gettext.pl	2007-08-15 14:52:00.000000000 +0200
@@ -10,7 +10,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: i18n-to-gettext.pl 1.2 2007/08/12 10:02:01 kls Exp $
+# $Id: i18n-to-gettext.pl 1.3 2007/08/15 12:52:00 kls Exp $
 
 # How to convert an actual plugin:
 #
@@ -75,7 +75,7 @@
 # Locate the file containing the texts:
 
 $I18NFILE = "";
-for ("i18n.c", `ls *.c`) { # try i18n.c explicitly first
+for ("i18n.c", "i18n.h", `ls *.c`) { # try i18n.[ch] explicitly first
     chomp($f = $_);
     if (-f $f && `grep tI18nPhrase $f`) {
        $I18NFILE = $f;
@@ -204,13 +204,28 @@
 # Collect all translated texts:
 
 open(F, $I18NFILE) || die "$I18NFILE: $!\n";
+$InComment = 0;
 while (<F>) {
       chomp;
       s/\t/ /g; # get rid of tabs
       s/  *$//; # get rid of trailing blanks
       s/^ *\/\/.*//; # remove comment lines
-      s/, *\/\/.*/,/; # strip trailing comments
+      s/ *\/\/.*//; # strip trailing comments
+      s/\/\*.*\*\///g; # strip c comments
+      if (/\/\*/) {
+         $InComment = 1;
+         s/\/\*.*$//; # remove start of comment
+         }
+      elsif (/\*\//) {
+         $InComment = 0;
+         s/^.*\*\///; # remove end of comment
+         }
+      elsif ($InComment) {
+         next;
+         }
       next if (/^ *$/); # skip empty lines
+      next if (/#if/);
+      next if (/#endif/);
       next unless ($found or $found = /const *tI18nPhrase .*{/); # sync on phrases
       next if (/const *tI18nPhrase .*{/); # skip sync line
       last if (/{ *NULL *}/); # stop after last phrase
@@ -324,7 +339,7 @@
          $_ .= " i18n";
          }
       elsif (/^clean:/) {
-	 $_ .= "\n\t\@-rm -f \$(PODIR)/*.mo \$(PODIR)/*.pot";
+         $_ .= "\n\t\@-rm -f \$(PODIR)/*.mo \$(PODIR)/*.pot";
          }
       print NEW "$_\n";
       }
diff -ruN vdr-1.5.7/i18n.c vdr-1.5.8/i18n.c
--- vdr-1.5.7/i18n.c	2007-08-12 14:15:29.000000000 +0200
+++ vdr-1.5.8/i18n.c	2007-08-19 16:10:46.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: i18n.c 1.308 2007/08/12 12:15:29 kls Exp $
+ * $Id: i18n.c 1.312 2007/08/19 14:10:46 kls Exp $
  *
  *
  */
@@ -23,6 +23,7 @@
 #include <ctype.h>
 #include <libintl.h>
 #include <locale.h>
+#include <unistd.h>
 #include "tools.h"
 
 // TRANSLATORS: The name of the language, as written natively
@@ -67,6 +68,7 @@
 static cStringList LanguageNames;
 static cStringList LanguageCodes;
 
+static int NumLocales = 1;
 static int CurrentLanguage = 0;
 
 static bool ContainsCode(const char *Codes, const char *Code)
@@ -90,6 +92,13 @@
   return p ? p + 1 : s;
 }
 
+static void SetEnvLanguage(const char *Locale)
+{
+  setenv("LANGUAGE", Locale, 1);
+  extern int _nl_msg_cat_cntr;
+  ++_nl_msg_cat_cntr;
+}
+
 void I18nInitialize(void)
 {
   LanguageLocales.Append(strdup(I18N_DEFAULT_LOCALE));
@@ -99,11 +108,13 @@
   bindtextdomain("vdr", I18nLocaleDir);
   cFileNameList Locales(I18nLocaleDir, true);
   if (Locales.Size() > 0) {
-     dsyslog("found %d locales in %s", Locales.Size(), I18nLocaleDir);
      char *OldLocale = strdup(setlocale(LC_MESSAGES, NULL));
      for (int i = 0; i < Locales.Size(); i++) {
-         if (i < I18N_MAX_LANGUAGES - 1) {
-            if (setlocale(LC_MESSAGES, Locales[i])) {
+         cString FileName = cString::sprintf("%s/%s/LC_MESSAGES/vdr.mo", I18nLocaleDir, Locales[i]);
+         if (access(FileName, F_OK) == 0) { // found a locale with VDR texts
+            if (i < I18N_MAX_LANGUAGES - 1) {
+               SetEnvLanguage(Locales[i]);
+               NumLocales++;
                if (strstr(OldLocale, Locales[i]) == OldLocale)
                   CurrentLanguage = LanguageLocales.Size();
                LanguageLocales.Append(strdup(Locales[i]));
@@ -117,12 +128,15 @@
                    }
                LanguageCodes.Append(strdup(Code));
                }
+            else {
+               esyslog("ERROR: too many locales - increase I18N_MAX_LANGUAGES!");
+               break;
+               }
             }
-         else
-            esyslog("ERROR: too many locales - increase I18N_MAX_LANGUAGES!");
          }
-     setlocale(LC_MESSAGES, OldLocale);
+     SetEnvLanguage(LanguageLocales[CurrentLanguage]);
      free(OldLocale);
+     dsyslog("found %d locales in %s", NumLocales - 1, I18nLocaleDir);
      }
   // Prepare any known language codes for which there was no locale:
   for (const char **lc = LanguageCodeList; *lc; lc++) {
@@ -144,7 +158,8 @@
 
 void I18nRegister(const char *Plugin)
 {
-  bindtextdomain(Plugin, I18nLocaleDir);
+  cString Domain = cString::sprintf("vdr-%s", Plugin);
+  bindtextdomain(Domain, I18nLocaleDir);
 }
 
 void I18nSetLocale(const char *Locale)
@@ -153,7 +168,7 @@
      int i = LanguageLocales.Find(Locale);
      if (i >= 0) {
         CurrentLanguage = i;
-        setlocale(LC_MESSAGES, Locale);
+        SetEnvLanguage(Locale);
         }
      else
         dsyslog("unknown locale: '%s'", Locale);
@@ -173,6 +188,11 @@
      }
 }
 
+int I18nNumLanguagesWithLocale(void)
+{
+  return NumLocales;
+}
+
 const cStringList *I18nLanguages(void)
 {
   return &LanguageNames;
@@ -180,6 +200,8 @@
 
 const char *I18nTranslate(const char *s, const char *Plugin)
 {
+  if (!s)
+     return s;
   if (CurrentLanguage) {
      const char *t = s;
      if (Plugin)
diff -ruN vdr-1.5.7/i18n.h vdr-1.5.8/i18n.h
--- vdr-1.5.7/i18n.h	2007-08-10 15:53:57.000000000 +0200
+++ vdr-1.5.8/i18n.h	2007-08-19 16:07:17.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: i18n.h 1.21 2007/08/10 13:53:57 kls Exp $
+ * $Id: i18n.h 1.23 2007/08/19 14:07:17 kls Exp $
  */
 
 #ifndef __I18N_H
@@ -36,9 +36,16 @@
 void I18nSetLanguage(int Language);
    ///< Sets the current language index to Language. If Language is outside
    ///< the range of available languages, nothing happens.
+int I18nNumLanguagesWithLocale(void);
+   ///< Returns the number of entries in the list returned by I18nLanguages()
+   ///< that actually have a locale.
 const cStringList *I18nLanguages(void);
    ///< Returns the list of available languages. Values returned by
    ///< I18nCurrentLanguage() are indexes into this list.
+   ///< Only the first I18nNumLanguagesWithLocale() entries in this list
+   ///< have an actual locale installed. The rest are just dummy entries
+   ///< to allow having three letter language codes for other languages
+   ///< that have no actual locale on this system.
 const char *I18nTranslate(const char *s, const char *Plugin = NULL) __attribute_format_arg__(1);
    ///< Translates the given string (with optional Plugin context) into
    ///< the current language. If no translation is available, the original
@@ -72,7 +79,7 @@
    ///< the second one (like "deu" out of ""eng+deu").
 
 #ifdef PLUGIN_NAME_I18N
-#define tr(s)  I18nTranslate(s, PLUGIN_NAME_I18N)
+#define tr(s)  I18nTranslate(s, "vdr-" PLUGIN_NAME_I18N)
 #else
 #define tr(s)  I18nTranslate(s)
 #endif
diff -ruN vdr-1.5.7/menu.c vdr-1.5.8/menu.c
--- vdr-1.5.7/menu.c	2007-08-12 12:44:35.000000000 +0200
+++ vdr-1.5.8/menu.c	2007-08-18 11:03:05.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 1.459 2007/08/12 10:44:35 kls Exp $
+ * $Id: menu.c 1.460 2007/08/18 09:03:05 kls Exp $
  */
 
 #include "menu.h"
@@ -2205,7 +2205,7 @@
   useSmallFontTexts[2] = tr("always");
   Clear();
   SetSection(tr("OSD"));
-  Add(new cMenuEditStraItem(tr("Setup.OSD$Language"),               &osdLanguageIndex, I18nLanguages()->Size(), &I18nLanguages()->At(0)));
+  Add(new cMenuEditStraItem(tr("Setup.OSD$Language"),               &osdLanguageIndex, I18nNumLanguagesWithLocale(), &I18nLanguages()->At(0)));
   Add(new cMenuEditStraItem(tr("Setup.OSD$Skin"),                   &skinIndex, numSkins, skinDescriptions));
   if (themes.NumThemes())
   Add(new cMenuEditStraItem(tr("Setup.OSD$Theme"),                  &themeIndex, themes.NumThemes(), themes.Descriptions()));
diff -ruN vdr-1.5.7/menuitems.c vdr-1.5.8/menuitems.c
--- vdr-1.5.7/menuitems.c	2007-08-04 11:12:18.000000000 +0200
+++ vdr-1.5.8/menuitems.c	2007-08-17 15:48:07.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menuitems.c 1.50 2007/08/04 09:12:18 kls Exp $
+ * $Id: menuitems.c 1.51 2007/08/17 13:48:07 kls Exp $
  */
 
 #include "menuitems.h"
@@ -222,7 +222,8 @@
 void cMenuEditChrItem::Set(void)
 {
   char buf[2];
-  snprintf(buf, sizeof(buf), "%c", *value);
+  buf[0] = *value;
+  buf[1] = '\0';
   SetValue(buf);
 }
 
@@ -490,9 +491,7 @@
                  break;
     case kBlue|k_Repeat:
     case kBlue:  // consume the key only if in edit-mode
-                 if (InEditMode())
-                    ;
-                 else
+                 if (!InEditMode())
                     return osUnknown;
                  break;
     case kLeft|k_Repeat:
diff -ruN vdr-1.5.7/newplugin vdr-1.5.8/newplugin
--- vdr-1.5.7/newplugin	2007-08-12 13:04:39.000000000 +0200
+++ vdr-1.5.8/newplugin	2007-08-19 16:19:49.000000000 +0200
@@ -12,7 +12,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: newplugin 1.34 2007/08/12 11:04:39 kls Exp $
+# $Id: newplugin 1.36 2007/08/19 14:19:49 kls Exp $
 
 $PLUGIN_NAME = $ARGV[0] || die "Usage: newplugin <name>\n";
 
@@ -108,6 +108,10 @@
 
 OBJS = \$(PLUGIN).o
 
+### The main target:
+
+all: libvdr-\$(PLUGIN).so i18n
+
 ### Implicit rules:
 
 %.o: %.c
@@ -144,13 +148,11 @@
 	\@mkdir -p \$(LOCALEDIR)
 	for i in \$(I18Ndirs); do\\
 	    mkdir -p \$(LOCALEDIR)/\$\$i/LC_MESSAGES;\\
-	    cp \$(PODIR)/\$\$i.mo \$(LOCALEDIR)/\$\$i/LC_MESSAGES/\$(PLUGIN).mo;\\
+	    cp \$(PODIR)/\$\$i.mo \$(LOCALEDIR)/\$\$i/LC_MESSAGES/vdr-\$(PLUGIN).mo;\\
 	    done
 
 ### Targets:
 
-all: libvdr-\$(PLUGIN).so i18n
-
 libvdr-\$(PLUGIN).so: \$(OBJS)
 	\$(CXX) \$(CXXFLAGS) -shared \$(OBJS) -o \$\@
 	\@cp --remove-destination \$\@ \$(LIBDIR)/\$\@.\$(APIVERSION)
diff -ruN vdr-1.5.7/nit.c vdr-1.5.8/nit.c
--- vdr-1.5.7/nit.c	2007-04-29 13:35:33.000000000 +0200
+++ vdr-1.5.8/nit.c	2007-08-17 16:02:45.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: nit.c 1.14 2007/04/29 11:35:33 kls Exp $
+ * $Id: nit.c 1.15 2007/08/17 14:02:45 kls Exp $
  */
 
 #include "nit.h"
@@ -140,13 +140,14 @@
                         }
                     break;
                     }
-                 bool found = false;
-                 for (cChannel *Channel = Channels.First(); Channel; Channel = Channels.Next(Channel)) {
-                     if (!Channel->GroupSep() && Channel->Source() == Source && Channel->Nid() == ts.getOriginalNetworkId() && Channel->Tid() == ts.getTransportStreamId()) {
-                        if (Setup.UpdateChannels >= 5) {
-                           if (!ISTRANSPONDER(cChannel::Transponder(Frequency, Polarization), Channel->Transponder())) {
+                 if (Setup.UpdateChannels >= 5) {
+                    bool found = false;
+                    for (cChannel *Channel = Channels.First(); Channel; Channel = Channels.Next(Channel)) {
+                        if (!Channel->GroupSep() && Channel->Source() == Source && Channel->Nid() == ts.getOriginalNetworkId() && Channel->Tid() == ts.getTransportStreamId()) {
+                           int transponder = Channel->Transponder();
+                           if (!ISTRANSPONDER(cChannel::Transponder(Frequency, Polarization), transponder)) {
                               for (int n = 0; n < NumFrequencies; n++) {
-                                  if (ISTRANSPONDER(cChannel::Transponder(Frequencies[n], Polarization), Channel->Transponder())) {
+                                  if (ISTRANSPONDER(cChannel::Transponder(Frequencies[n], Polarization), transponder)) {
                                      Frequency = Frequencies[n];
                                      break;
                                      }
@@ -157,16 +158,16 @@
                            }
                         found = true;
                         }
-                     }
-                 if (!found && Setup.UpdateChannels >= 5) {
-                    for (int n = 0; n < NumFrequencies; n++) {
-                        cChannel *Channel = new cChannel;
-                        Channel->SetId(ts.getOriginalNetworkId(), ts.getTransportStreamId(), 0, 0);
-                        if (Channel->SetSatTransponderData(Source, Frequencies[n], Polarization, SymbolRate, CodeRate))
-                           EITScanner.AddTransponder(Channel);
-                        else
-                           delete Channel;
-                        }
+                    if (!found) {
+                       for (int n = 0; n < NumFrequencies; n++) {
+                           cChannel *Channel = new cChannel;
+                           Channel->SetId(ts.getOriginalNetworkId(), ts.getTransportStreamId(), 0, 0);
+                           if (Channel->SetSatTransponderData(Source, Frequencies[n], Polarization, SymbolRate, CodeRate))
+                              EITScanner.AddTransponder(Channel);
+                           else
+                              delete Channel;
+                           }
+                       }
                     }
                  }
                  break;
@@ -190,13 +191,14 @@
                         }
                     break;
                     }
-                 bool found = false;
-                 for (cChannel *Channel = Channels.First(); Channel; Channel = Channels.Next(Channel)) {
-                     if (!Channel->GroupSep() && Channel->Source() == Source && Channel->Nid() == ts.getOriginalNetworkId() && Channel->Tid() == ts.getTransportStreamId()) {
-                        if (Setup.UpdateChannels >= 5) {
-                           if (!ISTRANSPONDER(Frequency / 1000, Channel->Transponder())) {
+                 if (Setup.UpdateChannels >= 5) {
+                    bool found = false;
+                    for (cChannel *Channel = Channels.First(); Channel; Channel = Channels.Next(Channel)) {
+                        if (!Channel->GroupSep() && Channel->Source() == Source && Channel->Nid() == ts.getOriginalNetworkId() && Channel->Tid() == ts.getTransportStreamId()) {
+                           int transponder = Channel->Transponder();
+                           if (!ISTRANSPONDER(Frequency / 1000, transponder)) {
                               for (int n = 0; n < NumFrequencies; n++) {
-                                  if (ISTRANSPONDER(Frequencies[n] / 1000, Channel->Transponder())) {
+                                  if (ISTRANSPONDER(Frequencies[n] / 1000, transponder)) {
                                      Frequency = Frequencies[n];
                                      break;
                                      }
@@ -207,16 +209,16 @@
                            }
                         found = true;
                         }
-                     }
-                 if (!found && Setup.UpdateChannels >= 5) {
-                    for (int n = 0; n < NumFrequencies; n++) {
-                        cChannel *Channel = new cChannel;
-                        Channel->SetId(ts.getOriginalNetworkId(), ts.getTransportStreamId(), 0, 0);
-                        if (Channel->SetCableTransponderData(Source, Frequencies[n], Modulation, SymbolRate, CodeRate))
-                           EITScanner.AddTransponder(Channel);
-                        else
-                           delete Channel;
-                        }
+                    if (!found) {
+                        for (int n = 0; n < NumFrequencies; n++) {
+                           cChannel *Channel = new cChannel;
+                           Channel->SetId(ts.getOriginalNetworkId(), ts.getTransportStreamId(), 0, 0);
+                           if (Channel->SetCableTransponderData(Source, Frequencies[n], Modulation, SymbolRate, CodeRate))
+                              EITScanner.AddTransponder(Channel);
+                           else
+                              delete Channel;
+                           }
+                       }
                     }
                  }
                  break;
@@ -247,13 +249,14 @@
                         }
                     break;
                     }
-                 bool found = false;
-                 for (cChannel *Channel = Channels.First(); Channel; Channel = Channels.Next(Channel)) {
-                     if (!Channel->GroupSep() && Channel->Source() == Source && Channel->Nid() == ts.getOriginalNetworkId() && Channel->Tid() == ts.getTransportStreamId()) {
-                        if (Setup.UpdateChannels >= 5) {
-                           if (!ISTRANSPONDER(Frequency / 1000000, Channel->Transponder())) {
+                 if (Setup.UpdateChannels >= 5) {
+                    bool found = false;
+                    for (cChannel *Channel = Channels.First(); Channel; Channel = Channels.Next(Channel)) {
+                        if (!Channel->GroupSep() && Channel->Source() == Source && Channel->Nid() == ts.getOriginalNetworkId() && Channel->Tid() == ts.getTransportStreamId()) {
+                           int transponder = Channel->Transponder();
+                           if (!ISTRANSPONDER(Frequency / 1000000, transponder)) {
                               for (int n = 0; n < NumFrequencies; n++) {
-                                  if (ISTRANSPONDER(Frequencies[n] / 1000000, Channel->Transponder())) {
+                                  if (ISTRANSPONDER(Frequencies[n] / 1000000, transponder)) {
                                      Frequency = Frequencies[n];
                                      break;
                                      }
@@ -264,15 +267,15 @@
                            }
                         found = true;
                         }
-                     }
-                 if (!found && Setup.UpdateChannels >= 5) {
-                    for (int n = 0; n < NumFrequencies; n++) {
-                        cChannel *Channel = new cChannel;
-                        Channel->SetId(ts.getOriginalNetworkId(), ts.getTransportStreamId(), 0, 0);
-                        if (Channel->SetTerrTransponderData(Source, Frequencies[n], Bandwidth, Constellation, Hierarchy, CodeRateHP, CodeRateLP, GuardInterval, TransmissionMode))
-                           EITScanner.AddTransponder(Channel);
-                        else
-                           delete Channel;
+                    if (!found) {
+                       for (int n = 0; n < NumFrequencies; n++) {
+                           cChannel *Channel = new cChannel;
+                           Channel->SetId(ts.getOriginalNetworkId(), ts.getTransportStreamId(), 0, 0);
+                           if (Channel->SetTerrTransponderData(Source, Frequencies[n], Bandwidth, Constellation, Hierarchy, CodeRateHP, CodeRateLP, GuardInterval, TransmissionMode))
+                              EITScanner.AddTransponder(Channel);
+                           else
+                              delete Channel;
+                           }
                         }
                     }
                  }
diff -ruN vdr-1.5.7/osd.c vdr-1.5.8/osd.c
--- vdr-1.5.7/osd.c	2007-08-12 13:33:17.000000000 +0200
+++ vdr-1.5.8/osd.c	2007-08-17 17:23:50.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.c 1.72 2007/08/12 11:33:17 kls Exp $
+ * $Id: osd.c 1.73 2007/08/17 15:23:50 kls Exp $
  */
 
 #include "osd.h"
@@ -449,13 +449,13 @@
      int w = Font->Width(s);
      int h = Font->Height();
      int limit = 0;
+     int cw = Width ? Width : w;
+     int ch = Height ? Height : h;
+     if (!Intersects(x, y, x + cw - 1, y + ch - 1))
+        return;
+     if (ColorBg != clrTransparent)
+        DrawRectangle(x, y, x + cw - 1, y + ch - 1, ColorBg);
      if (Width || Height) {
-        int cw = Width ? Width : w;
-        int ch = Height ? Height : h;
-        if (!Intersects(x, y, x + cw - 1, y + ch - 1))
-           return;
-        if (ColorBg != clrTransparent)
-           DrawRectangle(x, y, x + cw - 1, y + ch - 1, ColorBg);
         limit = x + cw - x0;
         if (Width) {
            if ((Alignment & taLeft) != 0)
@@ -482,8 +482,6 @@
               }
            }
         }
-     else if (!Intersects(x, y, x + w - 1, y + h - 1))
-        return;
      x -= x0;
      y -= y0;
      Font->DrawText(this, x, y, s, ColorFg, ColorBg, limit);
diff -ruN vdr-1.5.7/vdr.c vdr-1.5.8/vdr.c
--- vdr-1.5.7/vdr.c	2007-08-12 13:22:04.000000000 +0200
+++ vdr-1.5.8/vdr.c	2007-08-18 15:03:46.000000000 +0200
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.cadsoft.de/vdr
  *
- * $Id: vdr.c 1.296 2007/08/12 11:22:04 kls Exp $
+ * $Id: vdr.c 1.298 2007/08/18 13:03:46 kls Exp $
  */
 
 #include <getopt.h>
@@ -704,10 +704,13 @@
 #endif
         // Attach launched player control:
         cControl::Attach();
+
+        time_t Now = time(NULL);
+
         // Make sure we have a visible programme in case device usage has changed:
         if (!EITScanner.Active() && cDevice::PrimaryDevice()->HasDecoder() && !cDevice::PrimaryDevice()->HasProgramme()) {
            static time_t lastTime = 0;
-           if (time(NULL) - lastTime > MINCHANNELWAIT) {
+           if (Now - lastTime > MINCHANNELWAIT) {
               cChannel *Channel = Channels.GetByNumber(cDevice::CurrentChannel());
               if (Channel && (Channel->Vpid() || Channel->Apid(0))) {
                  if (!Channels.SwitchTo(cDevice::CurrentChannel()) // try to switch to the original channel...
@@ -716,7 +719,7 @@
                      && !cDevice::SwitchChannel(-1)) // ...or the next lower available one
                     ;
                  }
-              lastTime = time(NULL); // don't do this too often
+              lastTime = Now; // don't do this too often
               LastTimerChannel = -1;
               }
            }
@@ -738,8 +741,8 @@
            if (modified == CHANNELSMOD_USER || Timers.Modified(TimerState))
               ChannelSaveTimeout = 1; // triggers an immediate save
            else if (modified && !ChannelSaveTimeout)
-              ChannelSaveTimeout = time(NULL) + CHANNELSAVEDELTA;
-           bool timeout = ChannelSaveTimeout == 1 || ChannelSaveTimeout && time(NULL) > ChannelSaveTimeout && !cRecordControls::Active();
+              ChannelSaveTimeout = Now + CHANNELSAVEDELTA;
+           bool timeout = ChannelSaveTimeout == 1 || ChannelSaveTimeout && Now > ChannelSaveTimeout && !cRecordControls::Active();
            if ((modified || timeout) && Channels.Lock(false, 100)) {
               if (timeout) {
                  Channels.Save();
@@ -767,16 +770,15 @@
            if (!Menu)
               Menu = new cDisplayChannel(cDevice::CurrentChannel(), LastChannel >= 0);
            LastChannel = cDevice::CurrentChannel();
-           LastChannelChanged = time(NULL);
+           LastChannelChanged = Now;
            }
-        if (time(NULL) - LastChannelChanged >= Setup.ZapTimeout && LastChannel != PreviousChannel[PreviousChannelIndex])
+        if (Now - LastChannelChanged >= Setup.ZapTimeout && LastChannel != PreviousChannel[PreviousChannelIndex])
            PreviousChannel[PreviousChannelIndex ^= 1] = LastChannel;
         // Timers and Recordings:
         if (!Timers.BeingEdited()) {
            // Assign events to timers:
            Timers.SetEvents();
            // Must do all following calls with the exact same time!
-           time_t Now = time(NULL);
            // Process ongoing recordings:
            cRecordControls::Process(Now);
            // Start new recordings:
@@ -863,7 +865,7 @@
                         }
                      }
                   }
-              LastTimerCheck = time(NULL);
+              LastTimerCheck = Now;
               }
            // Delete expired timers:
            Timers.DeleteExpired();
@@ -1065,7 +1067,7 @@
                     continue;
                     }
                  }
-              else if (time(NULL) - cRemote::LastActivity() > MENUTIMEOUT)
+              else if (Now - cRemote::LastActivity() > MENUTIMEOUT)
                  state = osEnd;
               }
            switch (state) {
@@ -1181,12 +1183,12 @@
               ShutdownHandler.countdown.Cancel();
            }
 
-        if (!Interact && !cRecordControls::Active() && !cCutter::Active() && !Interface->HasSVDRPConnection() && (time(NULL) - cRemote::LastActivity()) > ACTIVITYTIMEOUT) {
+        if (!Interact && !cRecordControls::Active() && !cCutter::Active() && !Interface->HasSVDRPConnection() && (Now - cRemote::LastActivity()) > ACTIVITYTIMEOUT) {
            // Handle housekeeping tasks
 
            // Shutdown:
            // Check whether VDR will be ready for shutdown in SHUTDOWNWAIT seconds:
-           time_t Soon = time(NULL) + SHUTDOWNWAIT;
+           time_t Soon = Now + SHUTDOWNWAIT;
            if (ShutdownHandler.IsUserInactive(Soon) && ShutdownHandler.Retry(Soon) && !ShutdownHandler.countdown) {
               if (ShutdownHandler.ConfirmShutdown(false))
                  // Time to shut down - start final countdown:
